package fxReseptit;

import javafx.scene.control.TextField;

import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import reseptit.Ainesosa;


/**
 * Ainesosalistan muokkausta käsittelevä kontrolleri.
 * @author Omistaja
 * @version 18.2.2025
 *
 */
public class AinesosaGUIController implements ModalControllerInterface<Ainesosa>{

    @FXML private TextField AinesosaNimi;
    
    @FXML private TextField AinesosanMaara;
    
    @FXML private ComboBoxChooser<String> AinesosaYksikko;

    @FXML private Button nPeruuta;

    @FXML private Button nTallennaAinesosa;

    
    
    private Ainesosa ain;
    
    
    /**
     * Lisää ainesosan ainesosalistaan.
     */
    @FXML void LisaaAinesosa() {
        if (oikeatKentat()) {
            ain.setNimi(AinesosaNimi.getText());
            ain.setMaara(Double.parseDouble(AinesosanMaara.getText()));
            ain.setYksikko(AinesosaYksikko.getSelectedText());  
            ModalController.closeStage(nPeruuta);
        }
        else Dialogs.showMessageDialog("Kentät täytetty väärin");        
    }
    
    
    /**
     * Tarkistaa onko kaikki kentät täytetty oikein
     * @return onko oikein täytetty
     */
    public boolean oikeatKentat() {
        String nimi = AinesosaNimi.getText();
        String maara = AinesosanMaara.getText();
        if (nimi.matches("[a-öA-Ö]+") && maara.matches("\\d+")) return true;
        return false;
    }

    
    /**
     * Peruuttaa edeltävään ikkunaan eli reseptin muokkaus ikkunaan.
     */
    @FXML void PeruutaReseptinMuokkaukseen() {
        ModalController.closeStage(nPeruuta);
    }


    @Override
    public Ainesosa getResult() {
        // TODO Auto-generated method stub
        return ain;
    }


    @Override
    public void handleShown() {
        //AAAAAAAAAAAAAAAAAAAAAa
    }


    @Override
    public void setDefault(Ainesosa oletus) {
        this.ain = oletus;
    }

}